<script setup lang="ts">
    import { useMsal } from '@/plugins/msal/useMsal'
    import { onUnmounted, ref, watch } from 'vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import { serviceOfferIdInjectionKey } from '@/shared/constants'
    import { SilabError } from '@/shared/errors/SilabError'
    import SListItem from '@/shared/item/components/SListItem.vue'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import { InterventionApi } from '@/logisticServiceOffer/entities/intervention/interventionApi'
    import { Intervention } from '@/logisticServiceOffer/entities/intervention/Intervention'
    import SContentContainerFullView from '@/shared/components/SContentContainerFullView.vue'
    import { useDisplay } from 'vuetify/lib/framework.mjs'
    import { useInterventionFilterStore } from '@/logisticServiceOffer/stores/InterventionFilterStore'
    import SInterventionsFilters from '@/logisticServiceOffer/components/intervention/SInterventionsFilters.vue'
    import { RequestAborter } from '@/shared/api/entities/RequestAborter'
    import { requiredInject } from '@/shared/helpers/types'
    import { useStoreKeys } from '@/shared/user/composables/useStoreKeys'

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const { mdAndUp } = useDisplay()

    const msal = useMsal()
    const userStore = useUserStore(msal)
    const interventionApi = new InterventionApi(msal)

    const { generateUserUrlScopedStoreKey } = useStoreKeys(msal)

    const interventions = ref<Array<Intervention> | undefined>(undefined)

    const interventionFilters = useInterventionFilterStore(
        generateUserUrlScopedStoreKey('InterventionFilter')
    ).interventionFilters
    const expandPanel = ref<boolean>(false)
    let délaisAvantRécupérationDesInterventionsEnMs = 0
    let callTimeout: number | undefined = undefined
    const interventionsFetchCallAborter: RequestAborter = new RequestAborter()
    const isLoading = ref<boolean>(false)

    watch(
        [
            () => msal.accounts,
            () => userStore.isImpersonating,
            interventionFilters,
        ],
        () => {
            interventionsFetchCallAborter.abortRequestsAndRefreshAborter()
            window.clearTimeout(callTimeout)
            if (interventionFilters.hasChangedFilters()) {
                délaisAvantRécupérationDesInterventionsEnMs = 750
            }
            isLoading.value = true
            interventions.value = undefined
            callTimeout = window.setTimeout(() => {
                interventionApi
                    .getAllDemandesDeFournitures(
                        serviceOfferId.value,
                        interventionFilters,
                        interventionsFetchCallAborter.getSignal()
                    )
                    .then((fetchedInterventions) => {
                        interventions.value = fetchedInterventions
                    })
                    .catch((error) => {
                        // dans le cas d'une annulation, on ne fait rien
                        if (error.name !== 'AbortError') {
                            throw new SilabError(
                                `Erreur lors de la récupération des interventions`,
                                error
                            )
                        }
                    })
                    .finally(() => {
                        isLoading.value = false
                    })
            }, délaisAvantRécupérationDesInterventionsEnMs)
            délaisAvantRécupérationDesInterventionsEnMs = 0
        },
        { immediate: true, deep: true }
    )
    onUnmounted(() => {
        interventionsFetchCallAborter.abortRequests()
    })
</script>

<template>
    <s-contextual-navbar
        page-title="Demandes de fourniture par Intervention"
        :page-is-loading="isLoading"
    >
        <template #contextualButtons>
            <template v-if="!mdAndUp"
                ><v-badge
                    v-if="interventionFilters.hasChangedFilters()"
                    data-cy="tune-badge"
                    :offset-y="10"
                    :offset-x="10"
                    class="mr-3"
                    color="error"
                    :content="interventionFilters.getChangedFiltersQuantity()"
                >
                    <v-btn
                        data-cy="btn-tune"
                        icon="mdi-tune"
                        color="on-background"
                        @click="expandPanel = !expandPanel"
                    ></v-btn>
                </v-badge>
                <v-btn
                    v-else
                    data-cy="btn-tune"
                    icon="mdi-tune"
                    color="on-background"
                    @click="expandPanel = !expandPanel"
                ></v-btn
            ></template>

            <v-btn
                v-if="
                    userStore.currentUserHasRoleForServiceOffer(
                        'LOGISTIQUE_INVENTORIER_ARTICLES',
                        serviceOfferId
                    )
                "
                data-cy="btn-stock-faire-inventaire"
                icon="mdi-clipboard-list-outline"
                color="on-background"
                :to="{
                    name: 'logistic-service-offer/inventaire/démarrer',
                    params: {
                        serviceOfferId,
                    },
                }"
            />
            <v-btn
                v-if="
                    userStore.currentUserHasRoleForServiceOffer(
                        'SERVICEOFFER_ADMIN_LIST_USERS',
                        serviceOfferId
                    )
                "
                data-cy="btn-stock-admin-user-list"
                icon="mdi-cog-outline"
                color="on-background"
                :to="{
                    name: 'LogisticServiceOffer/administration/utilisateurs/liste',
                    params: {
                        serviceOfferId,
                    },
                }"
            />
        </template>
    </s-contextual-navbar>
    <v-main>
        <s-content-container-full-view class="d-flex overflow-auto">
            <template v-if="mdAndUp">
                <div
                    id="side-sheet-content-desktop"
                    class="px-2"
                    style="
                        position: relative;
                        min-width: 400px;
                        overflow-y: auto;
                        height: 100%;
                    "
                >
                    <s-interventions-filters v-model="interventionFilters" />
                </div>
            </template>
            <v-navigation-drawer
                v-if="!mdAndUp"
                v-model="expandPanel"
                location="right"
                data-cy="filter-panel"
            >
                <s-interventions-filters v-model="interventionFilters" />
            </v-navigation-drawer>

            <div style="width: 100%; max-width: 1200px" class="px-md-0 px-3">
                <h2 class="py-4">Interventions avec demande de fourniture</h2>
                <v-list>
                    <template
                        v-for="intervention in interventions"
                        :key="intervention.id"
                        ><v-divider></v-divider>
                        <s-list-item
                            :item="intervention"
                            no-image
                            :to="{
                                name: 'logistic-service-offer/interventions/détails',
                                params: {
                                    interventionId: intervention.id,
                                    serviceOfferId,
                                },
                            }"
                        />
                    </template>
                    <template
                        v-if="
                            interventions !== undefined &&
                            interventions.length === 0 &&
                            interventionFilters.hasChangedFilters()
                        "
                        ><v-divider></v-divider>
                        <p class="pa-3">
                            Aucune intervention trouvée, veuillez essayer
                            d'autre filtres de recherche
                        </p>
                        <div v-if="!mdAndUp" class="cente">
                            <v-btn
                                v-if="interventionFilters.hasChangedFilters()"
                                variant="text"
                                class="text-body-2"
                                @click="interventionFilters.resetFilters()"
                            >
                                Réinitialiser les filtres
                            </v-btn>
                        </div>
                    </template>
                </v-list>
            </div>
        </s-content-container-full-view>
    </v-main>
</template>
